diff --git a/board/firefly/roc-pc-rk3399/MAINTAINERS b/board/firefly/roc-pc-rk3399/MAINTAINERS
index 68a5b757d1df..d26e3c4cd2ba 100644
--- a/board/firefly/roc-pc-rk3399/MAINTAINERS
+++ b/board/firefly/roc-pc-rk3399/MAINTAINERS
@@ -6,3 +6,8 @@ F:	board/firefly/roc-pc-rk3399
 F:	include/configs/roc-pc-rk3399.h
 F:	configs/roc-pc-rk3399_defconfig
 F:	configs/roc-pc-mezzanine-rk3399_defconfig
+F:	arch/arm/dts/rk3399-roc-pc.dts
+F:	arch/arm/dts/rk3399-roc-pc.dtsi
+F:	arch/arm/dts/rk3399-roc-pc-u-boot.dtsi
+F:	arch/arm/dts/rk3399-roc-pc-mezzanine.dts
+F:	arch/arm/dts/rk3399-roc-pc-mezzanine-u-boot.dtsi
diff --git a/board/pine64/pinebook-pro-rk3399/MAINTAINERS b/board/pine64/pinebook-pro-rk3399/MAINTAINERS
index 7300ca1b1b81..b80fc5cb6021 100644
--- a/board/pine64/pinebook-pro-rk3399/MAINTAINERS
+++ b/board/pine64/pinebook-pro-rk3399/MAINTAINERS
@@ -2,7 +2,7 @@ PINEBOOK_PRO
 M:	Peter Robinson <pbrobinson@gmail.com>
 S:	Maintained
 F:	board/pine64/pinebook-pro-rk3399/
-F:	include/configs/rk3399-pinebook-pro.h
+F:	include/configs/pinebook-pro-rk3399.h
 F:	arch/arm/dts/rk3399-pinebook-pro.dts
 F:	arch/arm/dts/rk3399-pinebook-pro-u-boot.dtsi
 F:	configs/pinebook-pro-rk3399_defconfig
diff --git a/board/pine64/pinephone-pro-rk3399/MAINTAINERS b/board/pine64/pinephone-pro-rk3399/MAINTAINERS
index bc2dcdd8d423..a2f4337cebc6 100644
--- a/board/pine64/pinephone-pro-rk3399/MAINTAINERS
+++ b/board/pine64/pinephone-pro-rk3399/MAINTAINERS
@@ -2,7 +2,7 @@ PINEPHONE_PRO
 M:	Peter Robinson <pbrobinson@gmail.com>
 S:	Maintained
 F:	board/pine64/pinephone-pro-rk3399/
-F:	include/configs/rk3399-pinephone-pro.h
+F:	include/configs/pinephone-pro-rk3399.h
 F:	arch/arm/dts/rk3399-pinephone-pro.dts
 F:	arch/arm/dts/rk3399-pinephone-pro-u-boot.dtsi
 F:	configs/pinephone-pro-rk3399_defconfig
diff --git a/board/pine64/rockpro64_rk3399/MAINTAINERS b/board/pine64/rockpro64_rk3399/MAINTAINERS
index 220ee21f230f..396363cc8d9b 100644
--- a/board/pine64/rockpro64_rk3399/MAINTAINERS
+++ b/board/pine64/rockpro64_rk3399/MAINTAINERS
@@ -3,5 +3,7 @@ M:	Jagan Teki <jagan@amarulasolutions.com>
 S:	Maintained
 F:	board/pine64/rockpro64_rk3399
 F:	include/configs/rockpro64_rk3399.h
+F:	arch/arm/dts/rk3399-rockpro64.dts
+F:	arch/arm/dts/rk3399-rockpro64.dtsi
 F:	arch/arm/dts/rk3399-rockpro64-u-boot.dtsi
 F:	configs/rockpro64-rk3399_defconfig
diff --git a/board/rockchip/evb_rk3399/MAINTAINERS b/board/rockchip/evb_rk3399/MAINTAINERS
index acdb840f2093..166e01bcc685 100644
--- a/board/rockchip/evb_rk3399/MAINTAINERS
+++ b/board/rockchip/evb_rk3399/MAINTAINERS
@@ -4,35 +4,45 @@ S:      Maintained
 F:      board/rockchip/evb_rk3399
 F:      include/configs/evb_rk3399.h
 F:      configs/evb-rk3399_defconfig
+F:      arch/arm/dts/rk3399-evb.dts
+F:      arch/arm/dts/rk3399-evb-u-boot.dtsi
 F:      configs/firefly-rk3399_defconfig
+F:      arch/arm/dts/rk3399-firefly.dts
+F:      arch/arm/dts/rk3399-firefly-u-boot.dtsi
 
 EAIDK-610
 M:      Andy Yan <andy.yan@rock-chips.com>
 S:      Maintained
 F:	configs/eaidk-610-rk3399_defconfig
+F:	arch/arm/dts/rk3399-eaidk-610.dts
 F:	arch/arm/dts/rk3399-eaidk-610-u-boot.dtsi
 
 KHADAS-EDGE
 M:	Nick Xie <nick@khadas.com>
 S:	Maintained
 F:	configs/khadas-edge-rk3399_defconfig
+F:	arch/arm/dts/rk3399-khadas-edge.dts
+F:	arch/arm/dts/rk3399-khadas-edge.dtsi
 F:	arch/arm/dts/rk3399-khadas-edge-u-boot.dtsi
 
 KHADAS-EDGE-CAPTAIN
 M:	Nick Xie <nick@khadas.com>
 S:	Maintained
 F:	configs/khadas-edge-captain-rk3399_defconfig
+F:	arch/arm/dts/rk3399-khadas-edge-captain.dts
 F:	arch/arm/dts/rk3399-khadas-edge-captain-u-boot.dtsi
 
 KHADAS-EDGE-V
 M:	Nick Xie <nick@khadas.com>
 S:	Maintained
 F:	configs/khadas-edge-v-rk3399_defconfig
+F:	arch/arm/dts/rk3399-khadas-edge-v.dts
 F:	arch/arm/dts/rk3399-khadas-edge-v-u-boot.dtsi
 
 LEEZ-P710
 M:	Andy Yan <andy.yan@rock-chips.com>
 S:      Maintained
+F:	arch/arm/dts/rk3399-leez-p710.dts
 F:	arch/arm/dts/rk3399-leez-p710-u-boot.dtsi
 F:	configs/leez-rk3399_defconfig
 
@@ -40,12 +50,14 @@ NANOPC-T4
 M:	Jagan Teki <jagan@amarulasolutions.com>
 S:	Maintained
 F:	configs/nanopc-t4-rk3399_defconfig
+F:	arch/arm/dts/rk3399-nanopc-t4.dts
 F:	arch/arm/dts/rk3399-nanopc-t4-u-boot.dtsi
 
 NANOPI-M4
 M:	Jagan Teki <jagan@amarulasolutions.com>
 S:	Maintained
 F:	configs/nanopi-m4-rk3399_defconfig
+F:	arch/arm/dts/rk3399-nanopi-m4.dts
 F:	arch/arm/dts/rk3399-nanopi-m4-u-boot.dtsi
 
 NANOPI-M4-2GB
@@ -53,12 +65,14 @@ M:	Jagan Teki <jagan@amarulasolutions.com>
 M:	Deepak Das <deepakdas.linux@gmail.com>
 S:	Maintained
 F:	configs/nanopi-m4-2gb-rk3399_defconfig
+F:	arch/arm/dts/rk3399-nanopi-m4-2gb.dts
 F:	arch/arm/dts/rk3399-nanopi-m4-2gb-u-boot.dtsi
 
 NANOPI-M4B
 M:	Alexandre Vicenzi <linux@alxd.me>
 S:	Maintained
 F:	configs/nanopi-m4b-rk3399_defconfig
+F:	arch/arm/dts/rk3399-nanopi-m4b.dts
 F:	arch/arm/dts/rk3399-nanopi-m4b-u-boot.dtsi
 
 NANOPI-NEO4
@@ -71,13 +85,14 @@ NANOPI-R4S
 M:	Xiaobo Tian <peterwillcn@gmail.com>
 S:	Maintained
 F:	configs/nanopi-r4s-rk3399_defconfig
+F:	arch/arm/dts/rk3399-nanopi-r4s.dts
 F:	arch/arm/dts/rk3399-nanopi-r4s-u-boot.dtsi
 
 ORANGEPI-RK3399
 M:	Jagan Teki <jagan@amarulasolutions.com>
 S:	Maintained
 F:	configs/orangepi-rk3399_defconfig
-F:	arch/arm/dts/rk3399-u-boot.dtsi
+F:	arch/arm/dts/rk3399-orangepi.dts
 F:	arch/arm/dts/rk3399-orangepi-u-boot.dtsi
 
 ROCK-4C+
@@ -85,23 +100,30 @@ M:	FUKAUMI Naoki <naoki@radxa.com>
 S:	Maintained
 F:	configs/rock-4c-plus-rk3399_defconfig
 F:	arch/arm/dts/rk3399-rock-4c-plus.dts
+F:	arch/arm/dts/rk3399-rock-4c-plus-u-boot.dtsi
 
 ROCK-4SE
 M:	Christopher Obbard <chris.obbard@collabora.com>
 S:	Maintained
 F:	configs/rock-4se-rk3399_defconfig
+F:	arch/arm/dts/rk3399-rock-4se.dts
 F:	arch/arm/dts/rk3399-rock-4se-u-boot.dtsi
 
 ROCK-PI-4
 M:	Jagan Teki <jagan@amarulasolutions.com>
 S:	Maintained
 F:	configs/rock-pi-4-rk3399_defconfig
+F:	arch/arm/dts/rk3399-rock-pi-4.dtsi
 F:	arch/arm/dts/rk3399-rock-pi-4-u-boot.dtsi
+F:	arch/arm/dts/rk3399-rock-pi-4a.dts
+F:	arch/arm/dts/rk3399-rock-pi-4a-u-boot.dtsi
 F:	configs/rock-pi-4c-rk3399_defconfig
+F:	arch/arm/dts/rk3399-rock-pi-4c.dts
 F:	arch/arm/dts/rk3399-rock-pi-4c-u-boot.dtsi
 
 ROCK-PI-N10
 M:	Jagan Teki <jagan@amarulasolutions.com>
 S:	Maintained
 F:	configs/rock-pi-n10-rk3399pro_defconfig
+F:	arch/arm/dts/rk3399pro-rock-pi-n10.dts
 F:	arch/arm/dts/rk3399pro-rock-pi-n10-u-boot.dtsi
diff --git a/board/vamrs/rock960_rk3399/MAINTAINERS b/board/vamrs/rock960_rk3399/MAINTAINERS
index 8821672a3abb..6a6d46a49b97 100644
--- a/board/vamrs/rock960_rk3399/MAINTAINERS
+++ b/board/vamrs/rock960_rk3399/MAINTAINERS
@@ -4,8 +4,13 @@ S:      Maintained
 F:      board/vamrs/rock960_rk3399/
 F:      include/configs/rock960_rk3399.h
 F:      configs/rock960-rk3399_defconfig
+F:      arch/arm/dts/rk3399-rock960.dts
+F:      arch/arm/dts/rk3399-rock960.dtsi
+F:      arch/arm/dts/rk3399-rock960-u-boot.dtsi
 
 FICUS EE
 M:      Manivannan Sadhasivam <manivannan.sadhasivam@linaro.org>
 S:      Maintained
 F:	configs/ficus-rk3399_defconfig
+F:	arch/arm/dts/rk3399-ficus.dts
+F:	arch/arm/dts/rk3399-ficus-u-boot.dtsi